//       .
//

#include "stdafx.h"
#include "ulp_lib.h"
#include "ulp_tools.h"
#include <iostream>
#include <conio.h>

using namespace std;

typedef struct {
	int64_t coordinate;	
	int64_t correction : 8;

	
} __CORRECTION_POINT_TYPEDEF;


uint8_t DrawMainMenu()
{
	cout << endl;
	cout << "1.     " << endl;
	cout << "2.     " << endl;
	cout << "3.     " << endl;
	cout << "4.     " << endl;
	cout << "5.     " << endl;
	cout << "6.     " << endl;
	cout << "0. " << endl;
	cout << " :";
	uint8_t result;
	cin >> result;
	cout << endl;
	return result;

}

bool DeleteCorrectionPoint(void* handle)
{
	uint8_t point_number;
	cout << "    :";
	cin >> point_number;
	point_number -= '0';
	bool result = false;
	if (ulp_clear_send_exchange(handle, 1, __ulp_m_sensor::__CMD::__DELETE_CORRECTION_POINT, &point_number, sizeof(point_number))
		&& (lastCommand.data_ptr[0] == ACK))
	{
		cout << " " << (int)point_number << " "<<endl;
		result = true;
	}
	return result;
}

//      .     .
bool ReadCorrectionPoint(__CORRECTION_POINT_TYPEDEF* _correction_point)
{
	try
	{

		cout << " :";
		int32_t coord;
		cin >> coord;
		cout << " :";
		int16_t correction;
		cin >> correction;
		_correction_point->coordinate = coord;
		_correction_point->correction= correction;
	}
	catch (exception ex)
	{
		return false;
	}
	return true;
}

//     
bool AddCorrectionPoint(void* handle)
{
	__CORRECTION_POINT_TYPEDEF correction_point;
	__CORRECTION_POINT_TYPEDEF* _pcorrection_point = &correction_point;



	return ReadCorrectionPoint(_pcorrection_point) &&
		ulp_clear_send_exchange(handle, 1, __ulp_m_sensor::__CMD::__ADD_CORRECTION_POINT_MANUAL, (uint8_t*)_pcorrection_point, sizeof(__CORRECTION_POINT_TYPEDEF)) &&
		lastCommand.data_ptr[0] == ACK;
}

//      
void DrawCorrectionTable(void* handle)
{
	//      
	uint8_t sensor_module_num = (uint8_t) __ulp_module::__TYPE::__SENSOR;
	uint8_t cpoints_num = 0;
	if (ulp_clear_send_exchange(handle, sensor_module_num, __ulp_m_sensor::__CMD::__GET_CORRECTION_POINT_NUM, NULL, 0))
	{
		cpoints_num = lastCommand.data_ptr[0];
	}

	if (!cpoints_num) cout << "  !"<<endl;
	else
	{
		cout << " \t\t"<<endl;
	}
	
	for (uint8_t i = 0; i < cpoints_num; i++)
	{
		
		if (ulp_clear_send_exchange(handle, 1, __ulp_m_sensor::__CMD::__GET_CORRECTION_POINT_INFO, &i, sizeof(i)))
		{
			__CORRECTION_POINT_TYPEDEF* pcorrection_data = (__CORRECTION_POINT_TYPEDEF*)lastCommand.data_ptr;
		
			cout << (int16_t)i << "\t\t" << pcorrection_data->coordinate << "\t\t" << (int16_t)pcorrection_data->correction << endl;
		}

	}

}


int _tmain(int argc, _TCHAR* argv[])
{
	setlocale(LC_ALL, "Russian");
	void* handle = NULL;
	_ulp_link::__CONNECTION_TYPE_TYPEDEF ctype = _ulp_link::__TYPE_USB;

	//         0.
	if (ulp_create_and_connect(ctype, 0, &handle)) cout << "    : OK !" << endl;
	else
	{
		cout << " !";
		return 1;
	}

	//         
	ulp_set_message_callback(handle, callback_handler);


	//   
	uint8_t data = 0;
	ulp_send_message(handle, 1, __ulp_module::__SHARED_CMD::__SET_MODULE_STATE, &data, sizeof(data));
	ulp_exchange(handle, ATIME, false);
	if (lastCommand.ndata_bytes && (lastCommand.data_ptr[0] == ACK))
	{
		cout << "  . "<<endl;
	}
	
	uint8_t input = 0;

	while ((input = DrawMainMenu()) != '0')
	{
		switch (input)
		{
		case '1':
		{
					DrawCorrectionTable(handle);
					break;
		}
		case '2':
		{
					if (ulp_clear_send_exchange(handle, 1, __ulp_m_sensor::__CMD::__INIT_CORRECTION_PROC, NULL, 0)
						&& lastCommand.data_ptr[0] == ACK)
					{
						cout << "  ." << endl;
					}
					break;
		}
		case '3':
		{
					if (AddCorrectionPoint(handle)) cout<<" ."<<endl;
					break;
		}
		case '4':
		{
					DeleteCorrectionPoint(handle);
					break;
		}
		case '5':
		{
					if (ulp_clear_send_exchange(handle, 1, __ulp_m_sensor::__CMD::__SAVE_CORRECTION_TABLE, NULL, 0)	&& (lastCommand.data_ptr[0] == ACK))
						cout << "     ." << endl;
					break;
		}
		case '6':
		{
					if (ulp_clear_send_exchange(handle, 1, __ulp_m_sensor::__CMD::__ABORT_CORRECTION_PROCESS, NULL, 0) && (lastCommand.data_ptr[0] == ACK))
						cout << "     ." << endl;
					break;
		}
		default:
			break;
		}
	}

	ulp_disconnect_and_free(handle);


	return 0;
}

