// TimerSensor.cpp 
//      .          ,  
//   .
//

#include "stdafx.h"
#include "../../inc/ulp_lib.h"
#include "../../inc/ulp_tools.h"
#include <iostream>
#include <conio.h>
#include "../../inc/module_virtual_io_types.h"
#include  "../../inc/module_func_remap_types.h"
#include "../../inc/sub_module_sensor_inc_types.h"
#include <fstream>

int _tmain(int argc, _TCHAR* argv[])
{


	setlocale(LC_ALL, "Russian");
	void* handle = NULL;
	_ulp_link::__CONNECTION_TYPE_TYPEDEF ctype = _ulp_link::__TYPE_USB;

	//         0.
	if (ulp_create_and_connect(ctype, 0, &handle)) cout << "  :OK !" << endl;
	else
	{
		cout << " !";
		return 1;
	}

	//         
	ulp_set_message_callback(handle, callback_handler);

	//!!!!!!!!!!!
	
	


	ulp_send_message(handle, __ulp_module::__TYPE::__SYSTEM, __ulp_m_system::__CMD::__GET_LOG_DATA, NULL, 0);
	
	ulp_exchange(handle, 0, false);



	// ,   1 -   

	uint8_t sensor_module_num = 1;
	ulp_send_message(handle, sensor_module_num, __ulp_module::__SHARED_CMD::__GET_MODULE_INFO, NULL, 0);
	ulp_exchange(handle, ATIME, false);
	if (lastCommand.ndata_bytes)
	{
		__ulp_module::__TYPE::__TYPEDEF module_type = (__ulp_module::__TYPE::__TYPEDEF)lastCommand.data_ptr[0];
		if (module_type == __ulp_module::__TYPE::__SENSOR) cout << "  " << (int)sensor_module_num << ": " << endl;

	}

	//  
	ulp_clear_last_command();

	//     ,   , 
	ulp_send_message(handle, sensor_module_num, __ulp_module::__SHARED_CMD::__GET_MODULE_STATE, NULL, 0);
	ulp_exchange(handle, ATIME, false);
	uint8_t isModuleDisable;
	if (lastCommand.ndata_bytes)
	{
		isModuleDisable = lastCommand.data_ptr[0]; // 0 -, 1- 
		if (isModuleDisable)
		{
			ulp_clear_last_command();
			//   
			uint8_t data = 0;
			ulp_send_message(handle, sensor_module_num, __ulp_module::__SHARED_CMD::__SET_MODULE_STATE, &data, sizeof(data));
			ulp_exchange(handle, ATIME, false);
			if (lastCommand.ndata_bytes && (lastCommand.data_ptr[0] == ACK))
			{
				isModuleDisable = 0;
			}

		}
		if (!isModuleDisable) cout << "   !" << endl;
		else
		{
			cout << "   !" << endl;

		}

	}

	//      "".

	//    
	uint8_t submodule = __ulp_m_sensor::__SUB_MODULE_TYPES::__INCREMENTAL;
	ulp_clear_last_command();
	ulp_send_message(handle, sensor_module_num, __ulp_module::__SHARED_CMD::__SET_MODULE_MODE, &submodule, sizeof(submodule));
	ulp_exchange(handle, ATIME, false);
	if (lastCommand.ndata_bytes && (lastCommand.data_ptr[0] == ACK))
		cout << "  : " << endl;

	ulp_clear_last_command();
	ulp_send_message(handle, sensor_module_num, __ulp_sm_sensor_inc::__CMD::__CLEAR_POSITION, NULL, 0);
	ulp_exchange(handle, ATIME, false);
	if (lastCommand.ndata_bytes && (lastCommand.data_ptr[0] == ACK))
		cout << " " << endl;
	
	//    /
	uint8_t virtual_io_module_num = 4; //     /
	ulp_clear_last_command();
	uint8_t data = 0;
	ulp_send_message(handle, virtual_io_module_num, __ulp_module::__SHARED_CMD::__SET_MODULE_STATE, &data, sizeof(data));
	ulp_exchange(handle, ATIME, false);
	if (lastCommand.ndata_bytes && (lastCommand.data_ptr[0] == ACK))
	{
		cout << "  / ." << endl;

	}

	int freq;
	cout << "    :";
	cin >> freq;
	uint32_t dfreq = 1000 / freq; //       
	//     ,  10 
	ulp_clear_last_command();
	//  ,  4 , 8    8  
	__ulp_m_virtual_io::__SETTINGS_TYPEDEF<4, 8, 8> v_io_settings;
	// 0- 
	v_io_settings.timers[0].pulse = false; //   
	v_io_settings.timers[0].max_cntr = dfreq; //   
	ulp_send_message(handle, virtual_io_module_num, __ulp_module::__SHARED_CMD::__SET_MODULE_SETTINGS, (uint8_t*)&v_io_settings, sizeof(__ulp_m_virtual_io::__SETTINGS_TYPEDEF<4, 8, 8>));
	ulp_exchange(handle, ATIME, false);
	if (lastCommand.ndata_bytes && (lastCommand.data_ptr[0] == ACK))
	{
		cout << " ." << endl;

	}

	//    
	uint8_t module_func_remap_num = 5; //     
	ulp_clear_last_command();
	data = 0;  // 0 -  
	ulp_send_message(handle, module_func_remap_num, __ulp_module::__SHARED_CMD::__SET_MODULE_STATE, &data, sizeof(data));
	ulp_exchange(handle, ATIME, false);
	if (lastCommand.ndata_bytes && (lastCommand.data_ptr[0] == ACK))
	{
		cout << "   ." << endl;

	}

	//            
	ulp_clear_last_command();
	ulp_send_message(handle, module_func_remap_num, 0x17, NULL, 0);
	ulp_exchange(handle, ATIME, false);
	uint8_t commands_num ; //  
	uint8_t write_buffer_command_num; //      
	uint8_t buff_overflow_command_num; //     
	if (lastCommand.ndata_bytes)
	{
		commands_num = lastCommand.ndata_bytes;
		cout << "  " << (int)commands_num<<"  ."<< endl;
		for (int i = 0; i < lastCommand.ndata_bytes; i++)
		{
			if (lastCommand.data_ptr[i] == __ulp_m_func_remap::__IN_FUNCTION_ID::__LOG_WRITE)
			{
				write_buffer_command_num = i;
			}
			if (lastCommand.data_ptr[i] == __ulp_m_func_remap::__OUT_FUNCTION_ID::__LOG_OVERFLOW)
			{
				buff_overflow_command_num = i;
			}

		}
		
		cout << "     :" << (int)write_buffer_command_num<<endl;
		cout << "    :" << (int)buff_overflow_command_num << endl;


	}

	uint32_t time_to_read;
	cout << "       :";
	cin >> time_to_read;
	
	//   ,     ,       
	ulp_clear_last_command();
	//     .     -919  12  , 19  
	//   4 
	__ulp_m_func_remap::__SETTINGS_TYPEDEF<12, 19, 4> func_remap_settings;

	//      
	func_remap_settings.in[write_buffer_command_num].ena = true; //      
	func_remap_settings.in[write_buffer_command_num].src.addr = 0; //  ,   
	func_remap_settings.in[write_buffer_command_num].src.src = __ulp_m_virtual_io::__SOURCE::__TIMERS ; //  
	func_remap_settings.in[write_buffer_command_num].src.trg = __ulp_m_virtual_io::__TRIGGERS::__EDGE; //    

	//     .        4 ( )
	func_remap_settings.out[buff_overflow_command_num].ena = true; // 
	func_remap_settings.out[buff_overflow_command_num].dst.addr = 4; //  
	func_remap_settings.out[buff_overflow_command_num].dst.dst = __ulp_m_virtual_io::__DESTINATION::__SELF_OUTPUTS; //  " " 



	ulp_send_message(handle, module_func_remap_num, __ulp_module::__SHARED_CMD::__SET_MODULE_SETTINGS, (uint8_t*)&func_remap_settings, sizeof(__ulp_m_func_remap::__SETTINGS_TYPEDEF<12, 19, 4>));
	
	ulp_exchange(handle, ATIME, false);
	if (lastCommand.ndata_bytes && (lastCommand.data_ptr[0] == ACK))
	{
		cout << "    ." << endl;

	}

	


	
	//    
	
	uint32_t tiks  = GetTickCount();
	while ((GetTickCount()- tiks) < time_to_read*1000)
	{
	
		//cout << inBuff_num << endl;
		ulp_send_message(handle, __ulp_module::__TYPE::__SYSTEM, __ulp_m_system::__CMD::__GET_LOG_DATA, NULL, 0);
		ulp_exchange(handle, 0, false);
	
		
	}

	//   
	ofstream f;
	f.open("result.txt", ios::out);
	for (int i = 0; i < buff_data.size();  i++)
	{
		f << i<< "\t"<<buff_data[i].coordinate << "\t"<< buff_data[i].status.all<<endl;
		
	}
	f.close();


	ulp_disconnect_and_free(handle);

	
	return 0;
}

