//      ,  ULP 
//    ,             
//     .

#include "stdafx.h"
#include <stdint.h>
#include <iostream>
#include <windows.h>
#include <process.h>
#include "ulp_lib.h"
#include "ulp_tools.h"
#include "module_sensor_types.h"
#include "module_system_types.h"
#include <link_types.h>
#include <vector>
#include <string>





int _tmain(int argc, _TCHAR* argv[])
{
	//   .     USB
	_ulp_link::__CONNECTION_TYPE_TYPEDEF ctype = _ulp_link::__TYPE_USB;

	vector<wstring> deviceList;

	//      ,   
	if (ulp_get_device_list(ctype, deviceList))
	{
		for (int i = 0; i < deviceList.size(); i++)
		{
			
			wcout<<"Device "<<i<< ": "<<deviceList[i]<<endl;
		}
	}

	void* handle = NULL;

	//         0.
	if (ulp_create_and_connect(ctype, 0, &handle)) cout<<"Create & Connect OK !"<<endl;
	

	//     COM ,  COM .    (247)
	if (ctype == _ulp_link::__TYPE_COM)
	{
		_ulp_link::__COM_SETTINGS_TYPEDEF settings;
		settings.baudrate = 115200;
		settings.dev_addr = 247;
		settings.nstop = _ulp_link::__STOP_BITS_1;
		settings.parity = _ulp_link::__PARITY_NO;
		if (ulp_change_link_settings(handle, &settings)) cout << "COM settings OK !" << endl;
	}

	//         
	ulp_set_message_callback(handle, callback_handler);

	//     ""    "    "    
	ulp_send_message(handle, __ulp_module::__TYPE::__SYSTEM, __ulp_m_system::__CMD::__GET_MODULES_NUM, NULL, 0);

	//      .      ,
	//  ATIME ,    .  ATIME   ,    
	//,     .
	ulp_exchange(handle, ATIME, false);

	uint8_t modules_num = 0;  //    

	//  ,   callback_handler,   lastCommand      .
	//         .
	if (lastCommand.ndata_bytes > 0) modules_num = lastCommand.data_ptr[0];

	cout << "Modules number :" << (int )modules_num<<endl;


	for (uint8_t i = 0; i < modules_num; i++)
	{
		//   lastCommand
		ulp_clear_last_command();

		//   "   "        
		ulp_send_message(handle, (__ulp_module::__TYPE::__TYPEDEF) i, __ulp_module::__SHARED_CMD::__GET_MODULE_INFO, NULL, 0);
		ulp_exchange(handle, ATIME, false);

		if (lastCommand.ndata_bytes > 0)
		{
			__ulp_module::__TYPE::__TYPEDEF type = (__ulp_module::__TYPE::__TYPEDEF)lastCommand.data_ptr[0];
			cout << "Module " << (int)i << " Type: " <<  module_type_strings[type] << "\t\t";
		}

		uint8_t submodules_num = 0;
		ulp_clear_last_command();
		
		//  "  "       
		ulp_send_message(handle, (__ulp_module::__TYPE::__TYPEDEF) i, __ulp_module::__SHARED_CMD::__GET_SUB_MODULE_NUM, NULL, 0);
		ulp_exchange(handle, ATIME, false);

		
		if (lastCommand.ndata_bytes > 0) submodules_num = lastCommand.data_ptr[0];
		cout << "Submodules number :" << (int)submodules_num << endl;
		for (uint8_t j = 0; j < submodules_num; j++)
		{
			ulp_clear_last_command();
			//   "   "       
			ulp_send_message(handle, (__ulp_module::__TYPE::__TYPEDEF) i, __ulp_module::__SHARED_CMD::__GET_SUB_MODULE_INFO, &j, sizeof(j));
			ulp_exchange(handle, ATIME, false);
			if (lastCommand.ndata_bytes > 0)
			{
				cout << "\t Submodule "<<(int)j<<"  type: " << (int)lastCommand.data_ptr[0]<<endl;
			}
		}
	}

	//       
	ulp_disconnect_and_free(handle);


	getchar();
	return 0;
}

