#include <lir919.h>


CLIR919::CLIR919() : tx(250), rx(250), plink(new _lir919_link::Clink_usb),
            message_callback(0)
{

}

CLIR919::~CLIR919(){
    if(plink) delete plink;
}

bool CLIR919::change_link(_lir919_link::__CONNECTION_TYPE_TYPEDEF _link){
    if(plink) delete plink;
    if(_link == _lir919_link::__TYPE_USB) plink = new _lir919_link::Clink_usb;
    else plink = new _lir919_link::Clink_com;

    return true;
}

uint32_t CLIR919::get_num_of_connected_devices(){
    plink->device_list_update();
    return plink->get_device_count();
}

bool CLIR919::get_name_of_device(uint32_t _dev_num, std::wstring* _str){
    return plink->get_device_name(_dev_num, _str);
}

_lir919_link::__CONNECTION_STATE_TYPEDEF CLIR919::get_link_state(){
    return plink->get_status();
}

_lir919_link::__CONNECTION_TYPE_TYPEDEF CLIR919::get_link_type(){
    return plink->get_type();
}

bool CLIR919::link_connect(uint8_t _device){
    bool res = plink->connect(_device);
    if(res) link_error_cntr = 0;
    return res;
}

bool CLIR919::link_disconnect(){
    return plink->disconnect();
}

void CLIR919::exchange(){
    if(plink->get_status() == _lir919_link::__STATE_DISCONNECTED) return;

    rx.init();
    if(plink->read(rx.get_ptr()) == 0){
        link_error_cntr++;
        if(link_error_cntr == 30) plink->disconnect();
    }
    else link_error_cntr = 0;

	__ulp_module::__TYPE::__TYPEDEF module;
    _cmd::__CMD_TYPEDEF command;

    while(rx.parse_packet(module, command)){
        if(message_callback != 0) message_callback(module, command);
		if (callback_adapter) callback_adapter(module, command.cmd, command.ptr, command.ndata_bytes);
    }

    plink->write(tx.get_ptr(), tx.get_packet_size());
    tx.init();
}

bool CLIR919::send_message(__ulp_module::__TYPE::__TYPEDEF _module, uint8_t _command, uint8_t* _data, uint32_t _data_size){
    return tx.add_message(_module, _command, _data, _data_size);
}

bool CLIR919::change_link_settings(uint8_t* _settings, uint16_t _settings_size){
    return plink->set_settings(_settings, _settings_size);
}


void CLIR919::set_message_callback_adapter(void(*_callback_adapter)(__ulp_module::__TYPE::__TYPEDEF& _module, uint8_t _cmd, uint8_t* _ptr, uint8_t ndata_bytes))
{
	callback_adapter = _callback_adapter;
}

void CLIR919::set_message_callback(void(*_f)(__ulp_module::__TYPE::__TYPEDEF& _module, _cmd::__CMD_TYPEDEF& _cmd)){
	
    message_callback = _f;
}
