// lir919.cpp : Defines the exported functions for the DLL application.
//




#include <windows.h>
#include <iostream>
#include "../../inc/lir919.h"
#include "../../inc/ulp_lib.h"


CLIR919 lir;

LIR_ULP_API uint32_t  ulp_get_num_of_connected_devices(_ulp_link::__CONNECTION_TYPE_TYPEDEF type)
{
	

	lir.change_link(type);
	return lir.get_num_of_connected_devices();
}

LIR_ULP_API bool ulp_link_connect(void* ulp_device,  uint8_t device_Number)
{
	CLIR919* device = (CLIR919*) ulp_device;
	uint32_t numDev = device ->get_num_of_connected_devices();
	return (device->link_connect(device_Number));
}

LIR_ULP_API bool ulp_link_disconnect(void* ulp_device)
{
	

	return ((CLIR919*)ulp_device)->link_disconnect();
	
	
}
LIR_ULP_API bool ulp_get_name_of_device(_ulp_link::__CONNECTION_TYPE_TYPEDEF,  uint8_t device_Number, wchar_t * device_Name)
{

	wstring result;
	if (lir.get_name_of_device(device_Number, &result))
	{
		const wchar_t * cstr = result.c_str();
		int i;
		for (i = 0; i < result.length(); i++)
		{
			device_Name[i] = cstr[i];
		}
		device_Name[i] = L'\0';
		return true;

	}
	else
	{
		return false;
	}
}


LIR_ULP_API void* ulp_create(_ulp_link::__CONNECTION_TYPE_TYPEDEF  connection_type = _ulp_link::__TYPE_USB)
{
	CLIR919* ulp_device = new CLIR919();
	ulp_device->change_link(connection_type);
	return ulp_device;
}

LIR_ULP_API void  ulp_free(void *ulp_device)
{
	delete (CLIR919*)ulp_device;
}
LIR_ULP_API bool ulp_change_link_settings(const void* ulp_device, _ulp_link::__COM_SETTINGS_TYPEDEF* settings)
{
	return ((CLIR919*)ulp_device)->change_link_settings((uint8_t*)settings, sizeof(_ulp_link::__COM_SETTINGS_TYPEDEF));
}


LIR_ULP_API bool ulp_send_message(void* ulp_device, uint8_t _module, uint8_t _command, uint8_t* _data, uint32_t _data_size)
{
	return ((CLIR919*)ulp_device)->send_message((__ulp_module::__TYPE::__TYPEDEF) _module, _command, _data, _data_size);
}

LIR_ULP_API void ulp_exchange(void* ulp_device, uint32_t SleepTime , bool ReadBeforeWrite)
{
	return  ((CLIR919*)ulp_device)->exchange(SleepTime, ReadBeforeWrite);
}

LIR_ULP_API void ulp_set_message_callback(const void* ulp_device, void(*_callback)(__ulp_module::__TYPE::__TYPEDEF& _module, uint8_t _cmd, uint8_t* _ptr, uint8_t ndata_bytes))
{
	((CLIR919*)ulp_device)->set_message_callback_adapter(_callback);
}