#pragma warning(disable : 4996)
#include "../../inc/link.h"
#include <cstdlib>
#include <list>
#include <stdlib.h>
#include <stdint.h>
using namespace std;
namespace _ulp_link {

Clink_base::Clink_base(__CONNECTION_TYPE_TYPEDEF _type) : connection_status(__STATE_DISCONNECTED), type(_type){

}

Clink_base::~Clink_base(){

}

__CONNECTION_STATE_TYPEDEF Clink_base::get_status(){
    return connection_status;
}

__CONNECTION_TYPE_TYPEDEF Clink_base::get_type(){
    return type;
}

bool Clink_base::set_settings(uint8_t* _settings, uint16_t _settings_size){
    return set_settings_ll(_settings, _settings_size);
}

uint32_t Clink_base::get_device_count(){
    return (uint32_t)device_list.size();
}

list<wstring> Clink_base::get_device_list()
{
	
	device_list_update();
	return device_list;
}
bool Clink_base::get_device_name(uint32_t _dev_num, std::wstring* _str){
    if(_dev_num >= get_device_count()) return false;

    _str->clear();
    std::list<wstring>::iterator i = device_list.begin();
    std::advance(i, _dev_num);
    _str->append(*i);

    return true;
}

bool Clink_com::set_settings_ll(uint8_t* _settings_ptr, uint16_t _settings_size){
    if(_settings_size != sizeof(__COM_SETTINGS_TYPEDEF)) return false;

    __COM_SETTINGS_TYPEDEF* config = reinterpret_cast<__COM_SETTINGS_TYPEDEF*>(_settings_ptr);
  
	//cur_cport = new ;

	//sp_return ret;

	//ret = sp_copy_port(aviable_ports[config->dev_addr], &cur_cport);
	sp_port_config struct_config;
	sp_port_config *p_config= &struct_config;
	sp_return ret = sp_get_config(this->cur_cport, p_config);
	if (ret) return false;

	p_config->baudrate = config->baudrate;
	
	switch (config->parity)
	{
	case  __PARITY_NO:  p_config->parity = (sp_parity::SP_PARITY_NONE); break;
	case __PARITY_EVEN: p_config->parity = (sp_parity::SP_PARITY_EVEN); break;
	case __PARITY_ODD: p_config->parity = (sp_parity::SP_PARITY_ODD); break;
	}

	p_config->stopbits = config->nstop;
	p_config->bits = 8;
	p_config->rts = sp_rts::SP_RTS_OFF;

	ret = sp_set_config(this->cur_cport, p_config);
	if (ret) return false;
	
	/*  com_port.setBaudRate(config->baudrate);

    com_port.setFlowControl(QSerialPort::NoFlowControl);
    com_port.setParity((QSerialPort::Parity)config->parity);
    com_port.setStopBits((QSerialPort::StopBits)config->nstop);
    com_port.setDataBits(QSerialPort::Data8);*/
    device_addr = config->dev_addr;
    return true;
}

Clink_com::Clink_com() : Clink_base(__TYPE_COM), device_addr(0){

}

Clink_com::~Clink_com(){
	
	if (aviable_ports) sp_free_port_list(aviable_ports);
}

void Clink_com::device_list_update(){
    wstring cur_device;

    device_list.clear();
	if (aviable_ports) sp_free_port_list(aviable_ports);
	sp_list_ports(&aviable_ports);

	sp_port **iter = aviable_ports;

	while (*iter !=NULL)
	{
		char* cname = (*iter)->name;
		wchar_t * wname = new wchar_t[strlen(cname)+1];
		mbstowcs(wname, cname, strlen(cname)+1);

		wstring port_name = wname;

		delete[] wname;
		device_list.push_back(port_name);
		iter++;
	}
	
	
   // com_devs.clear();

   /* foreach(const QSerialPortInfo &info, QSerialPortInfo::availablePorts()){
        com_devs.push_back(info);
        cur_device.clear();

        wchar_t port_name[20], desc[50], info_str[70];
        info.portName().toWCharArray(port_name);
        info.description().toWCharArray(desc);
        swprintf_s(info_str, L"%s: %s", port_name, desc);
        cur_device.append(info_str);

        device_list.push_back(cur_device);
    }*/
}

bool Clink_com::connect(uint8_t _device){
  
	
	this->cur_cport = aviable_ports[_device];
	sp_return result = sp_open(cur_cport, SP_MODE_READ_WRITE);

	if (result != SP_OK) return false;
	else
	{
		connection_status = __STATE_CONNECTED;
		return true;
	}

	

	/*  com_port.setPortName(com_devs[_device].portName());
    if(com_port.open(QIODevice::ReadWrite)){
        connection_status = __STATE_CONNECTED;
        return true;
    }*/

    return false;
}

bool Clink_com::disconnect(){
 
	if (connection_status == __STATE_CONNECTED) sp_close(this->cur_cport);
	//   if(com_port.isOpen()) com_port.close();
    connection_status = __STATE_DISCONNECTED;
    return true;
}

bool Clink_com::write(uint8_t* buff, uint32_t size){
	if (connection_status == __STATE_DISCONNECTED) return false;
    if(size > 252) return false;

    uint8_t* send_buff = new uint8_t[size+5];

    send_buff[0] = device_addr;
    send_buff[1] = 0x2b;
    send_buff[2] = 1;

    for(uint8_t i = 0; i < size; i++){
        send_buff[3+i] = buff[i];
    }

    uint16_t res = CRC_Calculate_Soft(send_buff, size + 3);

    send_buff[size + 3] = (uint8_t)(res & 0xFF);
    send_buff[size + 4] = (uint8_t)((res >> 8) & 0xFF);

    bool result = true;

	
	uint16_t sizeOfMes = size  + 5;

	if (sizeOfMes != sp_blocking_write(cur_cport, (char*)send_buff, sizeOfMes, SP_TIMEOUT))
	{
		result = false;
	}
		

    delete [] send_buff;

    return result;
}

uint32_t Clink_com::read(uint8_t* buff){
	if (connection_status == __STATE_DISCONNECTED) return false;

    uint8_t rx_buff[256];

	uint8_t size = 0; 
	
	size = sp_blocking_read(cur_cport, rx_buff, sizeof(rx_buff), SP_TIMEOUT);
	//com_port.read((char*)rx_buff, sizeof(rx_buff));

	if (size)
	{
		int a;
	}

    if(rx_buff[0] != device_addr) return 0;
    if(rx_buff[1] != 0x2b) return 0;
    if(rx_buff[2] != 1) return 0;

    if(size < 5) return 0;

    uint16_t rx_crc = (rx_buff[size - 1] << 8) | rx_buff[size - 2];
    if(CRC_Calculate_Soft(rx_buff, size - 2) != rx_crc) return false;

    for(uint8_t i = 0; i < (size - 5); i++){
        buff[i] = rx_buff[3 + i];
    }

    return (size - 5);
}


bool Clink_usb::set_settings_ll(uint8_t* _settings_ptr, uint16_t _settings_size){
    return false;
}

Clink_usb::Clink_usb() : Clink_base(__TYPE_USB){

}

Clink_usb::~Clink_usb(){

}

void Clink_usb::device_list_update(){
    device_list.clear();
    usb_port.get_skbis_devices(device_list);
}

bool Clink_usb::connect(uint8_t _device){
    if(usb_port.open_dev(_device)){
        connection_status = __STATE_CONNECTED;
        return true;
    }
    return false;
}

bool Clink_usb::disconnect(){
    if(usb_port.is_open()) usb_port.close_dev();
    connection_status = __STATE_DISCONNECTED;
    return true;
}

bool Clink_usb::write(uint8_t* buff, uint32_t size){
    if(!usb_port.is_open()) return false;
	
    return usb_port.write_stream(buff, size);
}

uint32_t Clink_usb::read(uint8_t* buff){
    if(!usb_port.is_open()) return false;

    return usb_port.read_stream(buff);
}


}
